#ifndef SERIAL_H
#define SERIAL_H

#ifdef ALLEGRO_WINDOWS
   #define COM1   0
   #define COM2   1
   #define COM3   2
   #define COM4   3
#else
   #define DZCOMM_SECONDARY_INCLUDE
   #include <dzcomm.h>
   #define COM1   _com1
   #define COM2   _com2
   #define COM3   _com3
   #define COM4   _com4
#endif

//read_comport returned data type
#define EMPTY    0
#define DATA     1
#define PROMPT   2

#define SPECIAL_DELIMITER   '\t'

//comport status
#define READY          0
#define NOT_OPEN       1
#define USER_IGNORED   2

//process_response return values
#define HEX_DATA       0
#define BUS_BUSY       1
#define BUS_ERROR      2
#define DATA_ERROR     3
#define DATA_ERROR2    4
#define ERR_NO_DATA    5
#define SERIAL_ERROR   6
#define RUBBISH        7

// timeouts
#define OBD_REQUEST_TIMEOUT   3400
#define ATZ_TIMEOUT           1100
#define AT_TIMEOUT            30

// function prototypes
void serial_module_init();
void serial_module_shutdown();
int open_comport();
void close_comport();
void send_command(char *command);
int read_comport(char *response);
void start_serial_timer(int delay);
void stop_serial_timer();
int process_response(const char *cmd_sent, char *msg_received);

// variables
volatile int serial_time_out;
volatile int serial_timer_running;

struct COMPORT {
   int number;
   int status;    // READY, NOT_OPEN, USER_IGNORED
} comport;

#endif
